;; This file:
;;   http://angg.twu.net/elisp/find-ealias.el.html
;;   http://angg.twu.net/elisp/find-ealias.el
;;           (find-angg "elisp/find-ealias.el")
;; Author: Eduardo Ochs <eduardoochs@gmail.com>
;; Date: 2022jan20
;;
;; (defun e () (interactive) (find-angg "elisp/find-ealias.el"))
;; (find-es "emacs" "find-ealias")

(defalias 'myalias1 'myalias2)
(defalias 'myalias2 'myalias3)
(defalias 'myalias3 'myfunction)
(defun myfunction () 42)

'(

  (load (buffer-file-name))

  ;; This jumps to the definition of `myfunction': 
  (find-function-noselect 'myalias2)

  (find-efunction   'myalias2)
  (find-efunctionpp 'myalias2)
  (find-ealias      'myalias2)

  ;; The sexp below generates a "*Help*" buffer in which the
  ;; first line has a button whose text is "/tmp/my.el".
  ;; Its action is to jump to the definition of `myalias2'.
  (describe-function   'myalias2)
  (find-efunctiondescr 'myalias2 "d-ea")
  (find-efunctiondescr 'myalias2 "d-ea" '(eek "RET"))

  (find-efunctiondescr 'myalias2)
  (find-efunctiondescr 'myalias2 "d-ea")
  (find-efunctiondescr 'myalias2 "d-ea" '(eek "<<button-describe>>"))
  (find-efunctiondescr 'myalias2 "d-ea" '(eek "M-h M-t"))
  (find-efunctiondescr 'myalias2 "d-ea" '(eek "M-h M-k RET"))
  (find-efunction 'push-button)
  (find-efunction 'help-button-action)
  (find-efunction 'help-do-xref)

  (progn (eek "C-x 1 C-x 3 C-x o")
	 (find-efunctiondescr 'myalias2 "d-ea")
	 (eek "C-x 2")
         (find-ebuffercontents (current-buffer) "d-ea")
         (eek "C-x o")
         (eek "M-h M-t")
	 )

  ;; (find-es "emacs" "find-mylog-links")
  ;; (find-mylog-links 'help-do-xref)
  ;;
  (setq  mylog nil)
  (defun mylog (f r) (setq mylog (cons (cons f r) mylog)))
  (defun mylog-help-do-xref (&rest r) (mylog 'help-do-xref r))
  (advice-add 'help-do-xref    :before 'mylog-help-do-xref)
  ;;
  (find-efunctiondescr 'myalias2 "d-ea")
  ;;
  (advice-remove 'help-do-xref         'mylog-help-do-xref)
  (find-2a nil '(find-eppp mylog))

  (help-do-xref
   nil 'help-function-def--button-function
   '(myalias2 "/home/edrx/elisp/find-ealias.el"))

  (defun find-ealias0 (symbol)
    (let ((file (symbol-file symbol 'defun)))
      (help-do-xref
       nil 'help-function-def--button-function
       `(,symbol ,file))))

  (find-ealias0 'myalias2)
  (find-ealias0 'myfunction)
  (find-ealias0 'pwoo)

  (defun woo () (+ 2 3))

)




;; Local Variables:
;; coding:  utf-8-unix
;; End:
